local LayerChecker = CreateFrame'Frame'

local layer_id = nil

LayerChecker:SetScript('OnUpdate', function() LayerChecker:UPDATE() end)
LayerChecker:SetScript('OnEvent', function(_, event, arg1, arg2)
  if event == 'ADDON_LOADED' and arg1 == 'LayerChecker' then
		if LCDB == nil then
			LCDB = {}
	    LayerChecker_Frame:Show()
		end
		if LCDB ~= nil then
			if LCDB["visible"] == true then
				LayerChecker_Frame:Show()
			else
				LayerChecker_Frame:Hide()
			end
		end
  elseif event == 'ZONE_CHANGED_NEW_AREA' then
    layer_id = nil
    LayerCheckerUI_onUpdate()
  elseif event == 'UPDATE_MOUSEOVER_UNIT' then
    LayerChecker:onTarget()
  end
end)

function LayerCheckerUI_onUpdate()
  LayerChecker_FrameTextA:SetText("Layer ID:");
  if layer_id ~= nil then
    LayerChecker_FrameTextB:SetText(layer_id);
    LayerChecker_FrameTextB:SetTextColor(1, 1, 1, 1)
    LayerChecker_FrameTextA:SetTextColor(1, 1, 1, 1)
  else
    LayerChecker_FrameTextB:SetText("N/A");
    LayerChecker_FrameTextB:SetTextColor(1, 0, 0, 0.5)
    LayerChecker_FrameTextA:SetTextColor(1, 1, 1, 0.5)
  end
end

function LayerChecker:onTarget()

  local guid = UnitGUID("mouseover")
  if guid ~= nil then
    local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid)

    if type == "Creature" then
      layer_id = zone_uid
    end
    LayerCheckerUI_onUpdate()
  end
end

function LayerChecker:UPDATE()

end

SLASH_LAYERCHECKER1, SLASH_LAYERCHECKER2 = '/lc', '/layerchecker'
function SlashCmdList.LAYERCHECKER(msg, editBox)
    if msg == 'show' then
			LayerChecker_Frame:Show()
			LayerChecker_Frame:Show()
			LCDB["visible"] = true
		elseif msg == 'hide' then
			LayerChecker_Frame:Hide()
			LayerChecker_Frame:Hide()
			LCDB["visible"] = false
    else
      DEFAULT_CHAT_FRAME:AddMessage(" ", 1.0, 1.0, 1.0);
      DEFAULT_CHAT_FRAME:AddMessage("|cff3399FFLayerChecker|r by Odors of Stalagg. v0.9b", 1.0, 1.0, 1.0);
			DEFAULT_CHAT_FRAME:AddMessage("|cff3399FF/lc show|r - show UI", 1.0, 1.0, 1.0);
      DEFAULT_CHAT_FRAME:AddMessage("|cff3399FF/lc hide|r - hide UI", 1.0, 1.0, 1.0);
    end
end

-- register event hooks
LayerChecker:RegisterEvent'ZONE_CHANGED_NEW_AREA'
LayerChecker:RegisterEvent'UPDATE_MOUSEOVER_UNIT'
LayerChecker:RegisterEvent'ADDON_LOADED'
